package com.example.SparkStructedStreaming.Service;

import org.apache.kafka.clients.producer.Callback;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.kafka.clients.producer.RecordMetadata;
import org.apache.kafka.common.serialization.StringSerializer;
import org.apache.spark.sql.ForeachWriter;

import java.util.Properties;

public class KafkaProducerImpl extends ForeachWriter<String> {
    private Properties kafkaProperties = new Properties();
    private KafkaProducer<String,String> kafkaProducer;


    @Override
    public boolean open ( long l, long l1 ) {
        kafkaProperties.put("bootstrap.servers","http://127.0.0.1:9092" );
        kafkaProperties.put("key.serializer", StringSerializer.class.getName());
        kafkaProperties.put("value.serializer", StringSerializer.class.getName());
        return true;
    }

    @Override
    public void process ( String message ) {
        kafkaProducer = new KafkaProducer<String, String>(kafkaProperties);

        kafkaProducer.send(new ProducerRecord<String, String>("sparkTopic", message), new Callback() {
            @Override
            public void onCompletion ( RecordMetadata metadata, Exception exception ) {
                if (exception == null) {
                    System.out.println("Saved Data is::"+metadata.toString());
//                    System.out.println("metadata : " + metadata);
                } else {
                    exception.printStackTrace();
                }
            }
        });
    }

    @Override
    public void close ( Throwable throwable ) {
        System.out.println("************************************************************************");
        System.out.println("Kafka producer Closed");
        kafkaProducer.close();
    }
}
